stages:
  - test
  - build
  - deploy

variables:
  DOCKER_HOST: "tcp://docker:2375"
  DOCKER_TLS_CERTDIR: ""

django test:
  stage: test
  image: python:3-alpine
  script:
    - pip install -r requirements.txt
    - python manage.py test
  tags:
    - docker

docker build:
  stage: build
  image: docker:stable
  services:
          - name: 'docker:20.10.12-dind'
            command: ['--tls=false']
  script:
    - sed -i "s/%%%BUILDTAG%%%/${CI_COMMIT_REF_SLUG}/g" blog/templates/blog/base.html
      #    - echo "CI_COMMIT_SHORT_SHA = ${CI_COMMIT_SHORT_SHA} = ${CI_COMMIT_SHORT_SHA:0:6}"
    - sed -i "s/ff9400/${CI_COMMIT_SHORT_SHA:0:6}/g" blog/static/css/blog.css
    - docker info
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
  tags:
    - docker

deploy to DEV:
  stage: deploy
  script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker pull ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
    - docker rm -f blog || echo 'Blog not found'
    - docker run --name blog -d -v blog_volume:/code/db -p 80:8000 ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
  tags:
    - dev-shell
